import {Emitter}from'./events.js';class AbstractMessageReader {
  errorEmitter;
  closeEmitter;
  constructor() {
    this.errorEmitter = new Emitter();
    this.closeEmitter = new Emitter();
  }
  unsubscribe() {
    this.errorEmitter.unsubscribe();
    this.closeEmitter.unsubscribe();
  }
  get onError() {
    return this.errorEmitter.event;
  }
  fireError(error) {
    this.errorEmitter.fire(this.asError(error));
  }
  get onClose() {
    return this.closeEmitter.event;
  }
  fireClose() {
    this.closeEmitter.fire(undefined);
  }
  asError(error) {
    if (error instanceof Error) {
      return error;
    }
    throw error;
    // return new Error(
    //     `Reader received error. Reason: ${typeof error.message === 'string' ? error.message : 'unknown'}`
    // )
  }
}
class AbstractMessageWriter {
  errorEmitter = new Emitter();
  closeEmitter = new Emitter();
  unsubscribe() {
    this.errorEmitter.unsubscribe();
    this.closeEmitter.unsubscribe();
  }
  get onError() {
    return this.errorEmitter.event;
  }
  fireError(error, message, count) {
    this.errorEmitter.fire([this.asError(error), message, count]);
  }
  get onClose() {
    return this.closeEmitter.event;
  }
  fireClose() {
    this.closeEmitter.fire(undefined);
  }
  asError(error) {
    if (error instanceof Error) {
      return error;
    }
    return new Error(`Writer received error. Reason: ${typeof error.message === 'string' ? error.message : 'unknown'}`);
  }
}export{AbstractMessageReader,AbstractMessageWriter};//# sourceMappingURL=transport.js.map
